Description

This is a guide on installing a self-hosted OFBiz instance on FreeBSD 12.2-RELEASE.

Prepare the Environment

o Make sure the system is up to date:

pkg update && pkg upgrade
e Add ofbiz user:

pw add user -n ofbiz -m -s /bin/sh -c "OFBiz"
e |nstall the dependencies:

pkg install openijdk8 git gradle

Configure PostgreSQL

¢ |nstall PostgreSQL:
pkg install postgresgl-jdbc postgresgl96-server postgresqgl96-client postgresgl96-contrib
e |nitialize, start, and enable postgresql at boot:

sysrc postgresgl_enable="YES"
service postgresgl initdb
service postgresqgl start

e |og in to postgresql user account and connect to database:
su — postgres
psgl —-d templatel

o Create a user:

CREATE USER ofbiz WITH PASSWORD 'SuperSecretPassword' CREATEDB;

o Create the databases & grant all privileges on database
CREATE DATABASE ofbizdb OWNER ofbiz encoding='UTF8';
CREATE DATABASE ofbizolapdb OWNER ofbiz encoding='UTF8';
CREATE DATABASE ofbiztenantdb OWNER ofbiz encoding='UTF8';

e Quit the database session

\gq

exit

Install OFBiz

e Download ofbiz:

su - ofbiz
git clone -b releasel8.12 https://github.com/apache/ofbiz-framework
cd ofbiz-framework

e Edit the entityengine.xml file:

vi framework/entity/config/entityengine.xml

o And modify the group-map section:

<delegator name="default" entity-model-reader="main" entity-group-reader="main"
entity-eca-reader="main" distributed-cache-clear-enabled="false">
<group-map group-name="org.apache.ofbiz" datasource-name="localpostgres"/>
<group-map group-name="org.apache.ofbiz.olap" datasource-name="localpostgresolap"/>
<group-map group-name="org.apache.ofbiz.tenant" datasource-name="localpostgrestenant"
/>
</delegator>
<delegator name="default-no-eca" entity-model-reader="main" entity-group-reader="main"
entity-eca-reader="main" entity-eca-enabled="false distributed-cache-clear-enabled="false"
>
<group-map group-name="org.apache.ofbiz" datasource-name="localpostgres"/>
<group-map group-name="org.apache.ofbiz.olap" datasource-name="localpostgresolap"/>
<group-map group-name="org.apache.ofbiz.tenant" datasource-name="localpostgrestenant"
/>
</delegator>
<delegator name="test" entity-model-reader="main" entity-group-reader="main"
entity-eca-reader="main">
<group-map group-name="org.apache.ofbiz" datasource-name="localpostgres"/>
<group-map group-name="org.apache.ofbiz.olap" datasource-name="localpostgresolap"/>
<group-map group-name="org.apache.ofbiz.tenant" datasource-name="localpostgrestenant"
/>
</delegator>

o Also modify the datasource section:

<datasource name="localpostgres"
helper-class="org.apache.ofbiz.entity.datasource.GenericHelperDAO"
schema-name="public"
field-type-name="postgres"
check-on-start="true"
add-missing-on-start="true"
use—fk-initially-deferred="false"
alias-view-columns="false"
join-style="ansi"
use-binary-type-for-blob="true"
use-order—-by-nulls="true"
result-fetch-size="50">
<read-data reader—-name="tenant"/>
<read-data reader—-name="seed"/>
<read-data reader—-name="seed-initial"/>
<read-data reader—-name="demo"/>
<read-data reader—-name="ext"/>
<read-data reader-name="ext-test"/>
<read-data reader—-name="ext-demo"/>
<inline-jdbc
jdbc-driver="org.postgresqgl.Driver"
jdbc-uri="jdbc:postgresqgl://127.0.0.1:5433/0fbizdb"
jdbc-username="ofbiz"
jdbc-password="SuperSecretPassword"
isolation-level="ReadCommitted"
pool-minsize="2"
pool-maxsize="250"
time-between-eviction-runs-millis="600000"/>
</datasource>
<datasource name="localpostgresolap"
helper-class="org.apache.ofbiz.entity.datasource.GenericHelperDAO"
schema—-name="public"
field-type—-name="postgres"
check-on-start="true"
add-missing-on-start="true"
use—fk-initially-deferred="false"
alias-view-columns="false"
join-style="ansi"
result-fetch-size="50"
use-binary-type-for-blob="true"
use-order-by-nulls="true">
<read-data reader-name="tenant"/>
<read-data reader—-name="seed"/>
<read-data reader—-name="seed-initial"/>
<read-data reader—-name="demo"/>
<read-data reader—name="ext"/>
<read-data reader—-name="ext-test"/>
<read-data reader—-name="ext-demo"/>
<inline-jdbc
jdbc-driver="org.postgresqgl.Driver"
Jjdbc-uri="jdbc:postgresqgl://127.0.0.1:5433/0fbizolapdb"
jdbc-username="ofbiz"
jdbc-password="SuperSecretPassword"
isolation-level="ReadCommitted"
pool-minsize="2"
pool-maxsize="250"
time-between—-eviction-runs-millis="600000"/>
</datasource>
<datasource name="localpostgrestenant"
helper-class="org.apache.ofbiz.entity.datasource.GenericHelperDAO"
schema—-name="public"
field-type—-name="postgres"
check-on-start="true"
add-missing-on-start="true"
use—fk-initially-deferred="false"
alias-view-columns="false"
join-style="ansi"
result-fetch-size="50"
use-binary-type-for-blob="true"
use—-order-by-nulls="true">
<read-data reader—-name="tenant"/>
<read-data reader—-name="seed"/>
<read-data reader-name="seed-initial"/>
<read-data reader-name="demo"/>
<read-data reader—-name="ext"/>
<read-data reader—name="ext-test"/>
<read-data reader—name="ext-demo"/>
<inline-jdbc

jdbc-driver="org.postgresqgl.Driver"
jdbc-uri="jdbc:postgresqgl://127.0.0.1:5433/0fbiztenantdb"
jdbc-username="ofbiz"
jdbc-password="SuperSecretPassword"
isolation-level="ReadCommitted"
pool-minsize="2"
pool-maxsize="250"
time-between-eviction-runs-millis="600000"/>

</datasource>

e Edit the build.gradle file:

vi build.gradle

o And insert the postgres jdbc to the end of the compile dependencies:

dependencies {
// ofbiz compile libs

compile 'org.postgresqgl:postgresqgl:42.2.18"'

e Compile ofbiz:

./gradlew cleanAll loadAll

Resources

e https://github.com/apache/ofbiz-framework
¢ https://github.com/apache/ofbiz-plugins
¢ https://cwiki.apache.org/confluence/display/OFBIZ/Setup+OFBiz+version+16.11.02+with+PostgreSQL +on+Windows

History

#1 - 11/18/2020 10:45 PM - Daniel Curtis

- Description updated

#2 - 11/23/2020 06:06 PM - Daniel Curtis

- Description updated

#3 - 11/24/2020 03:34 PM - Daniel Curtis
- Description updated
- Status changed from New to In Progress

- % Done changed from 0 to 50

#4 - 12/12/2020 01:01 AM - Daniel Curtis
- Status changed from In Progress to Resolved

- % Done changed from 50 to 100

#5 - 02/18/2022 08:07 PM - Daniel Curtis

- Status changed from Resolved to Closed
